@echo off
title Install Vitis App
setlocal EnableDelayedExpansion

cd ..

set /p existing_path="Existing app path: "

REM Client Dir
echo Create client directory
if exist "client" (
  rmdir /S /Q "client"
)
echo copy client
robocopy "src/vitis/client" "client" /E /NFL /NDL /NJH /NJS /nc /ns /np
echo copy client/conf
robocopy "conf" "client/conf" /E /NFL /NDL /NJH /NJS /nc /ns /np
echo copy client/conf/closure
robocopy "src/closure/conf" "client/conf/closure" /E /NFL /NDL /NJH /NJS /nc /ns /np

echo Copy client modules
for /d %%g in ("src/module_*") do (
  set x=%%g
  echo !x:~7!
  if exist "src/%%g/module" (
    echo copy client/modules/!x:~7!
    robocopy "src/%%g/module" "client/modules/!x:~7!" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
)

REM VAS dir
echo Create vas directory
echo Create client directory
if exist "vas" (
  rmdir /S /Q "vas"
)
echo copy vas
robocopy "src/vitis/vas" "vas" /E /NFL /NDL /NJH /NJS /nc /ns /np

echo Copy vas web_services
for /d %%g in ("src/module_*") do (
  set x=%%g
  echo !x:~7!
  if exist "src/%%g/web_service/conf" (
    echo copy vas/rest/conf/!x:~7!
    robocopy "src/%%g/web_service/conf" "vas/rest/conf/!x:~7!" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist "src/%%g/web_service/sql" (
    echo copy vas/sql/!x:~7!
    robocopy "src/%%g/web_service/sql" "vas/sql/!x:~7!" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist "src/%%g/web_service/ws" (
    echo copy vas/rest/ws/!x:~7!
    robocopy "src/%%g/web_service/ws" "vas/rest/ws/!x:~7!" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist "src/%%g/web_service/class" (
    echo copy vas/rest/class
    robocopy "src/%%g/web_service/class" "vas/rest/class" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist "src/%%g/web_service/ws_data" (
    echo copy vas/ws_data
    robocopy "src/%%g/web_service/ws_data" "vas/ws_data" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist "src/%%g/web_service/public" (
    echo copy vas/public
    robocopy "src/%%g/web_service/public" "vas/public" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist "src/%%g/web_service/upload" (
    echo copy vas/upload
    robocopy "src/%%g/web_service/upload" "vas/upload" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
)

REM Copy from existing path
if exist %existing_path% (
  echo copy properties from %existing_path%

  for %%G in (vas\server,vas\rest\conf,vas\log,vas\public,vas\shared,vas\tmp,vas\upload,vas\ws_data) do (
    echo %%G
    if exist %existing_path%\%%G (
      echo copy %%G
      robocopy "%existing_path%\%%G" "%%G" /E /NFL /NDL /NJH /NJS /nc /ns /np
    )
  )

  if exist %existing_path%\client\conf\properties.json (
    echo copy properties.json
    robocopy "%existing_path%\client\conf" "client\conf" "properties.json" /NFL /NDL /NJH /NJS /nc /ns /np
  )
  if exist %existing_path%\vas\rest\.htaccess (
    echo copy .htaccess
    robocopy "%existing_path%\vas\rest" "vas\rest" ".htaccess" /NFL /NDL /NJH /NJS /nc /ns /np
  )

  if exist "%existing_path%\vas\rest\conf" (
    echo copy vas\rest\conf
    robocopy "%existing_path%\vas\rest\conf" "vas\rest\conf" /E /NFL /NDL /NJH /NJS /nc /ns /np
  )
)
